/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package InitialSchedules;

import java.util.List;
import org.chocosolver.solver.Solution;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.exception.ContradictionException;

/**
 *
 * @author frabe
 */
public class SolverInitialSchedules {
    
    Solver solverInitialSchedules;
    
    public SolverInitialSchedules (ModelFullTimeEmployeesInitialSchedules myModelFullTimeEmployeesInitialSchedules){
            
        this.solverInitialSchedules = myModelFullTimeEmployeesInitialSchedules.chocoModelInitialSchedules.getSolver();
        try {
            solverInitialSchedules.propagate();
        } catch (ContradictionException e) {
            System.err.println("Caught ContradictionException: " + e.getMessage());
            solverInitialSchedules.getEngine().flush();
        } catch (Exception e) {
            System.err.println("Caught Exception: " + e.getMessage());
        }
        solverInitialSchedules.setRestartOnSolutions();
        solverInitialSchedules.limitSolution(1);
//        solverInitialSchedules.limitTime(10000);
            
    }
    
    public SolverInitialSchedules (ModelPartTimeEmployeesInitialSchedules myModelPartTimeEmployeesInitialSchedules){
            
        this.solverInitialSchedules = myModelPartTimeEmployeesInitialSchedules.chocoModelInitialSchedules.getSolver();
        try {
            solverInitialSchedules.propagate();
        } catch (ContradictionException e) {
            System.err.println("Caught ContradictionException: " + e.getMessage());
            solverInitialSchedules.getEngine().flush();
        } catch (Exception e) {
            System.err.println("Caught Exception: " + e.getMessage());
        }
        solverInitialSchedules.setRestartOnSolutions();
        solverInitialSchedules.limitSolution(1);
//        solverInitialSchedules.limitTime(100000);
            
    }
    
    public List<Solution> findAllSolution() {
        List<Solution> myInitialSchedulesSolutions;
        myInitialSchedulesSolutions = solverInitialSchedules.findAllSolutions();
        return myInitialSchedulesSolutions;
    }
    
}
